=== debian/changelog ===
encfs (1.9.5-1build5) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Tue, 23 Nov 2021 15:55:42 +0100

encfs (1.9.5-1build4) jammy; urgency=medium

  * No-change rebuild against libtinyxml2-9

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Nov 2021 17:33:46 +0000

encfs (1.9.5-1build3) groovy; urgency=medium

  * Rebuild against new libtinyxml2-8.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 21 May 2020 22:56:19 +0200

encfs (1.9.5-1build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:13:25 +0100

encfs (1.9.5-1build1) cosmic; urgency=medium

  * Rebuild against new libtinyxml2-6a.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 08 Aug 2018 12:00:21 +0200

encfs (1.9.5-1) unstable; urgency=low

  * New upstream release
  * Dropped linkatomic.patch (merged in upstream)
  * Rebuilding with recent libstdc++ (hopefully closes: #898670, #898256)
  * sv.po for Debconf update by Jonatan Nyberg (closes: #872651)

 -- Eduard Bloch <blade@debian.org>  Wed, 30 May 2018 17:59:56 +0200
