=== debian/control ===
Source: encfs
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Eduard Bloch <blade@debian.org>
Build-Depends: debhelper (>= 9.0), libfuse-dev (>> 2.6), libssl-dev (>> 0.9.8), libtinyxml2-dev, dpkg-dev (>= 1.17), cmake (>> 3.2)
Standards-Version: 3.9.8
Homepage: http://www.arg0.net/encfs
Vcs-Browser: https://salsa.debian.org/debian/encfs
Vcs-Git: https://salsa.debian.org/debian/encfs.git

Package: encfs
Architecture: linux-any kfreebsd-any
Depends: ${shlibs:Depends}, ${misc:Depends}, mount (>> 2.19.1), fuse [linux-any] | fuse4bsd [kfreebsd-any]
Description: encrypted virtual filesystem
 EncFS integrates file system encryption into the Unix(TM) file system.
 Encrypted data is stored within the native file system, thus no
 fixed-size loopback image is required.
 .
 EncFS uses the FUSE kernel driver and library as a backend.
