=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*)?v?(\d[\d\.]*)\.tar\.gz/encfs-$1.tar.gz/" \
https://github.com/vgough/encfs/releases .*/encfs-([\d\.]+)\.tar\.gz
